## fdm 1.4

=== Makefile ===
# $Id: Makefile,v 1.162 2007/10/01 18:38:48 nicm Exp $

.SUFFIXES: .c .o .y .h
.PHONY: clean lint regress yannotate manual \
	update-index.html upload-index.html

PROG= fdm
VERSION= 1.4

OS!= uname
REL!= uname -r
DATE!= date +%Y%m%d-%H%M

# This must be empty as OpenBSD includes it in default CFLAGS.
#DEBUG=

SRCS= fdm.c \
      attach.c buffer.c cleanup.c command.c connect.c io.c log.c netrc.c \
      child-deliver.c child-fetch.c child.c \
      pcre.c re.c privsep.c replace.c shm-mmap.c strb.c db-tdb.c \
      xmalloc-debug.c xmalloc.c timer.c \
      deliver-add-header.c deliver-drop.c deliver-keep.c deliver-maildir.c \
      deliver-mbox.c deliver-pipe.c deliver-remove-header.c deliver-rewrite.c \
      deliver-smtp.c deliver-stdout.c deliver-tag.c deliver-to-cache.c \
      deliver-write.c \
      fetch-imap.c fetch-imappipe.c fetch-maildir.c fetch-nntp.c fetch-pop3.c \
      fetch-pop3pipe.c fetch-stdin.c fetch-mbox.c pop3-common.c imap-common.c \
      mail-state.c mail-time.c mail.c file.c \
      match-all.c match-age.c match-attachment.c match-command.c \
      match-in-cache.c match-matched.c match-regexp.c match-size.c \
      match-string.c match-tagged.c match-unmatched.c match-account.c \
      parent-deliver.c parent-fetch.c \
      parse.y parse-fn.c lex.c
HDRS= fdm.h array.h fetch.h match.h deliver.h

YACC= yacc -d

CC?= cc
INCDIRS+= -I. -I- -I/usr/local/include
.ifdef PROFILE
# Don't use ccache
CC= /usr/bin/gcc
CFLAGS+= -pg -DPROFILE -fprofile-arcs -ftest-coverage -O0
.endif
.ifdef DEBUG
CFLAGS+= -g -ggdb -DDEBUG
LDFLAGS+= -Wl,-E
CFLAGS+= -DBUILD="\"$(VERSION) ($(DATE))\""
.else
CFLAGS+= -DBUILD="\"$(VERSION)\""
.endif
#CFLAGS+= -pedantic -std=c99
CFLAGS+= -Wno-long-long -Wall -W -Wnested-externs -Wformat=2
CFLAGS+= -Wmissing-prototypes -Wstrict-prototypes -Wmissing-declarations
CFLAGS+= -Wwrite-strings -Wshadow -Wpointer-arith -Wcast-qual -Wsign-compare
CFLAGS+= -Wundef -Wshadow -Wbad-function-cast -Winline -Wcast-align

.ifdef PCRE
CFLAGS+= -DPCRE
LIBS+= -lpcre
.endif

# OS X
.if ${OS} == "Darwin"
SRCS+= compat/strtonum.c
INCDIRS+= -Icompat -I/usr/local/include/openssl
CFLAGS+= -DNO_STRTONUM -DNO_SETRESUID -DNO_SETRESGID -DNO_SETPROCTITLE
.endif

# NetBSD
.if ${OS} == "NetBSD"
SRCS+= compat/strtonum.c
INCDIRS+= -Icompat -I/usr/pkg/include
CFLAGS+= -DNO_STRTONUM -DNO_SETRESUID -DNO_SETRESGID
LDFLAGS+= -L/usr/pkg/lib
.endif

# FreeBSD
.if ${OS} == "FreeBSD"
INCDIRS+= -Icompat -I/usr/local/include/openssl

# FreeBSD 5
.if ${REL:R} == 5
SRCS+= compat/strtonum.c
CFLAGS+= -DNO_STRTONUM
.endif
.endif

PREFIX?= /usr/local
INSTALLBIN= install -g bin -o root -m 555
INSTALLMAN= install -g bin -o root -m 444

LDFLAGS+= -L/usr/local/lib
.ifdef PROFILE
LDFLAGS+= -pg
.endif
LIBS+= -lssl -lcrypto -ltdb -lz

OBJS= ${SRCS:S/.c/.o/:S/.y/.o/}

DISTFILES= *.[chyl] Makefile GNUmakefile *.[1-9] fdm-sanitize \
	   README MANUAL TODO CHANGES \
	   `find examples compat -type f -and ! -path '*CVS*'`

CLEANFILES= ${PROG} *.o compat/*.o y.tab.c y.tab.h .depend \
	    ${PROG}-*.tar.gz *~ */*~ *.ln ${PROG}.core MANUAL index.html

.c.o:
		${CC} ${CFLAGS} ${INCDIRS} -c ${.IMPSRC} -o ${.TARGET}

.y.o:
		${YACC} ${.IMPSRC}
		${CC} ${CFLAGS} ${INCDIRS} -c y.tab.c -o ${.TARGET}

all:		${PROG}

${PROG}:	${OBJS}
		${CC} ${LDFLAGS} -o ${PROG} ${LIBS} ${OBJS}

dist:		clean manual
		grep '^#DEBUG=' Makefile
		grep '^#DEBUG=' GNUmakefile
		[ "`(grep '^VERSION' Makefile; grep '^VERSION' GNUmakefile)| \
			uniq -u`" = "" ]
		tar -zc \
			-s '/.*/${PROG}-${VERSION}\/\0/' \
			-f ${PROG}-${VERSION}.tar.gz ${DISTFILES}

lint:
		lint -cehvx ${CFLAGS:M-D*} ${SRCS:M*.c}

depend:
		mkdep ${CFLAGS} ${INCDIRS} ${SRCS:M*.c}

regress:	${PROG}
		cd regress && ${MAKE}

yannotate:
		awk -f yannotate.awk parse.y > parse.y.new
		mv parse.y.new parse.y
		trim parse.y

upload-index.html:
		scp index.html nicm@shell.sf.net:index.html
		ssh nicm@shell.sf.net sh update-index-fdm.sh

update-index.html: manual
		nroff -mdoc fdm.conf.5|m2h -u > fdm.conf.5.html
		nroff -mdoc fdm.1|m2h -u > fdm.1.html
		awk -v V=${VERSION} -f makeindex.awk index.html.in > index.html
		rm -f fdm.conf.5.html fdm.1.html

manual:
		awk -f makemanual.awk MANUAL.in > MANUAL

install:	all
		${INSTALLBIN} ${PROG} ${DESTDIR}${PREFIX}/bin/${PROG}
		${INSTALLMAN} ${PROG}.1 ${DESTDIR}${PREFIX}/man/man1/
		${INSTALLMAN} ${PROG}.conf.5 ${DESTDIR}${PREFIX}/man/man5/

uninstall:
		rm -f ${DESTDIR}${PREFIX}/bin/${PROG}
		rm -f ${DESTDIR}${PREFIX}/man/man1/${PROG}.1
		rm -f ${DESTDIR}${PREFIX}/man/man5/${PROG}.conf.5

clean:
		rm -f ${CLEANFILES}

## fdm 1.5

=== Makefile ===
--- 
+++ 
@@ -1,11 +1,11 @@
-# $Id: Makefile,v 1.162 2007/10/01 18:38:48 nicm Exp $
+# $Id: Makefile,v 1.170 2008/03/03 18:39:25 nicm Exp $
 
 .SUFFIXES: .c .o .y .h
 .PHONY: clean lint regress yannotate manual \
 	update-index.html upload-index.html
 
 PROG= fdm
-VERSION= 1.4
+VERSION= 1.5
 
 OS!= uname
 REL!= uname -r
@@ -21,11 +21,11 @@
       xmalloc-debug.c xmalloc.c timer.c \
       deliver-add-header.c deliver-drop.c deliver-keep.c deliver-maildir.c \
       deliver-mbox.c deliver-pipe.c deliver-remove-header.c deliver-rewrite.c \
-      deliver-smtp.c deliver-stdout.c deliver-tag.c deliver-to-cache.c \
-      deliver-write.c \
+      deliver-smtp.c deliver-stdout.c deliver-tag.c deliver-add-to-cache.c \
+      deliver-remove-from-cache.c deliver-write.c \
       fetch-imap.c fetch-imappipe.c fetch-maildir.c fetch-nntp.c fetch-pop3.c \
       fetch-pop3pipe.c fetch-stdin.c fetch-mbox.c pop3-common.c imap-common.c \
-      mail-state.c mail-time.c mail.c file.c \
+      mail-state.c mail-time.c mail.c file.c cache-op.c \
       match-all.c match-age.c match-attachment.c match-command.c \
       match-in-cache.c match-matched.c match-regexp.c match-size.c \
       match-string.c match-tagged.c match-unmatched.c match-account.c \
@@ -53,7 +53,7 @@
 CFLAGS+= -Wno-long-long -Wall -W -Wnested-externs -Wformat=2
 CFLAGS+= -Wmissing-prototypes -Wstrict-prototypes -Wmissing-declarations
 CFLAGS+= -Wwrite-strings -Wshadow -Wpointer-arith -Wcast-qual -Wsign-compare
-CFLAGS+= -Wundef -Wshadow -Wbad-function-cast -Winline -Wcast-align
+CFLAGS+= -Wundef -Wbad-function-cast -Winline -Wcast-align
 
 .ifdef PCRE
 CFLAGS+= -DPCRE
@@ -77,7 +77,7 @@
 
 # FreeBSD
 .if ${OS} == "FreeBSD"
-INCDIRS+= -Icompat -I/usr/local/include/openssl
+INCDIRS+= -Icompat -I/usr/include/openssl
 
 # FreeBSD 5
 .if ${REL:R} == 5
@@ -87,6 +87,7 @@
 .endif
 
 PREFIX?= /usr/local
+INSTALLDIR= install -d
 INSTALLBIN= install -g bin -o root -m 555
 INSTALLMAN= install -g bin -o root -m 444
 
@@ -98,12 +99,13 @@
 
 OBJS= ${SRCS:S/.c/.o/:S/.y/.o/}
 
+DISTDIR= ${PROG}-${VERSION}
 DISTFILES= *.[chyl] Makefile GNUmakefile *.[1-9] fdm-sanitize \
 	   README MANUAL TODO CHANGES \
-	   `find examples compat -type f -and ! -path '*CVS*'`
+	   `find examples compat regress -type f -and ! -path '*CVS*'`
 
 CLEANFILES= ${PROG} *.o compat/*.o y.tab.c y.tab.h .depend \
-	    ${PROG}-*.tar.gz *~ */*~ *.ln ${PROG}.core MANUAL index.html
+	    ${DISTDIR}.tar.gz *~ */*~ *.ln ${PROG}.core MANUAL index.html
 
 .c.o:
 		${CC} ${CFLAGS} ${INCDIRS} -c ${.IMPSRC} -o ${.TARGET}
@@ -123,8 +125,8 @@
 		[ "`(grep '^VERSION' Makefile; grep '^VERSION' GNUmakefile)| \
 			uniq -u`" = "" ]
 		tar -zc \
-			-s '/.*/${PROG}-${VERSION}\/\0/' \
-			-f ${PROG}-${VERSION}.tar.gz ${DISTFILES}
+			-s '/.*/${DISTDIR}\/\0/' \
+			-f ${DISTDIR}.tar.gz ${DISTFILES}
 
 lint:
 		lint -cehvx ${CFLAGS:M-D*} ${SRCS:M*.c}
@@ -154,8 +156,11 @@
 		awk -f makemanual.awk MANUAL.in > MANUAL
 
 install:	all
+		${INSTALLDIR} ${DESTDIR}${PREFIX}/bin
 		${INSTALLBIN} ${PROG} ${DESTDIR}${PREFIX}/bin/${PROG}
+		${INSTALLDIR} ${DESTDIR}${PREFIX}/man/man1
 		${INSTALLMAN} ${PROG}.1 ${DESTDIR}${PREFIX}/man/man1/
+		${INSTALLDIR} ${DESTDIR}${PREFIX}/man/man5
 		${INSTALLMAN} ${PROG}.conf.5 ${DESTDIR}${PREFIX}/man/man5/
 
 uninstall:

=== regress/Makefile ===
# $Id: Makefile,v 1.17 2007/10/11 09:14:09 nicm Exp $

CLEANFILES= *~

TESTFILES!= echo *.test

TARGETS=
.for n in ${TESTFILES}
TARGETS+= ${n}
${n}:
		@echo ${n}:
		@HOME=. awk -v CMD="../fdm -vvvnf /dev/stdin" \
			-v DEBUG=${DEBUG} -f test.awk ${n}
.endfor

.MAIN:		all
.PHONY: 	regress clean ${TARGETS}
.PRECIOUS: 	${TARGETS}

all:		regress

regress:	${TARGETS}
		cd tests && ${MAKE}
		cd test-pop3 && ${MAKE}
		cd test-imap && ${MAKE}

clean:
		rm -f ${CLEANFILES}

=== regress/test-imap/Makefile ===
# $Id: Makefile,v 1.1 2007/10/11 09:14:09 nicm Exp $

CLEANFILES= *~ *.fifo.{in,out} *.log *.conf

TESTFILES!= echo imap-*.test

TARGETS=
.for n in ${TESTFILES}
TARGETS+= ${n}
${n}:
		@HOME=. FDM=../../fdm sh test-imap.sh ${n}
.endfor

.MAIN:		all
.PHONY: 	regress clean ${TARGETS}
.PRECIOUS: 	${TARGETS}

all:		regress

regress:	${TARGETS}

clean:
		rm -f ${CLEANFILES}

=== regress/test-pop3/Makefile ===
# $Id: Makefile,v 1.1 2007/10/10 20:32:07 nicm Exp $

CLEANFILES= *~ *.fifo.{in,out} *.log *.conf

TESTFILES!= echo pop3-*.test

TARGETS=
.for n in ${TESTFILES}
TARGETS+= ${n}
${n}:
		@HOME=. FDM=../../fdm sh test-pop3.sh ${n}
.endfor

.MAIN:		all
.PHONY: 	regress clean ${TARGETS}
.PRECIOUS: 	${TARGETS}

all:		regress

regress:	${TARGETS}

clean:
		rm -f ${CLEANFILES}

=== regress/tests/Makefile ===
# $Id: Makefile,v 1.1 2007/08/30 21:46:33 nicm Exp $

CLEANFILES= *~ *.in *.out *.data *.conf

TESTFILES!= echo *.sh

TARGETS=
.for n in ${TESTFILES}
TARGETS+= ${n}
${n}:
		@HOME=. FDM=../../fdm sh ${n}
.endfor

.MAIN:		all
.PHONY: 	regress clean ${TARGETS}
.PRECIOUS: 	${TARGETS}

all:		regress

regress:	${TARGETS}

clean:
		rm -f ${CLEANFILES}

## fdm 1.6

=== Makefile ===
--- 
+++ 
@@ -1,11 +1,11 @@
-# $Id: Makefile,v 1.170 2008/03/03 18:39:25 nicm Exp $
+# $Id: Makefile,v 1.176 2008/12/22 16:20:05 nicm Exp $
 
 .SUFFIXES: .c .o .y .h
 .PHONY: clean lint regress yannotate manual \
 	update-index.html upload-index.html
 
 PROG= fdm
-VERSION= 1.5
+VERSION= 1.6
 
 OS!= uname
 REL!= uname -r
@@ -22,7 +22,7 @@
       deliver-add-header.c deliver-drop.c deliver-keep.c deliver-maildir.c \
       deliver-mbox.c deliver-pipe.c deliver-remove-header.c deliver-rewrite.c \
       deliver-smtp.c deliver-stdout.c deliver-tag.c deliver-add-to-cache.c \
-      deliver-remove-from-cache.c deliver-write.c \
+      deliver-remove-from-cache.c deliver-write.c deliver-imap.c \
       fetch-imap.c fetch-imappipe.c fetch-maildir.c fetch-nntp.c fetch-pop3.c \
       fetch-pop3pipe.c fetch-stdin.c fetch-mbox.c pop3-common.c imap-common.c \
       mail-state.c mail-time.c mail.c file.c cache-op.c \
@@ -30,6 +30,7 @@
       match-in-cache.c match-matched.c match-regexp.c match-size.c \
       match-string.c match-tagged.c match-unmatched.c match-account.c \
       parent-deliver.c parent-fetch.c \
+      lookup.c lookup-passwd.c lookup-courier.c \
       parse.y parse-fn.c lex.c
 HDRS= fdm.h array.h fetch.h match.h deliver.h
 
@@ -54,6 +55,11 @@
 CFLAGS+= -Wmissing-prototypes -Wstrict-prototypes -Wmissing-declarations
 CFLAGS+= -Wwrite-strings -Wshadow -Wpointer-arith -Wcast-qual -Wsign-compare
 CFLAGS+= -Wundef -Wbad-function-cast -Winline -Wcast-align
+
+.ifdef COURIER
+CFLAGS+= -DLOOKUP_COURIER
+LIBS+= -lcourierauth
+.endif
 
 .ifdef PCRE
 CFLAGS+= -DPCRE
@@ -117,7 +123,7 @@
 all:		${PROG}
 
 ${PROG}:	${OBJS}
-		${CC} ${LDFLAGS} -o ${PROG} ${LIBS} ${OBJS}
+		${CC} ${LDFLAGS} -o ${PROG} ${OBJS} ${LIBS}
 
 dist:		clean manual
 		grep '^#DEBUG=' Makefile

=== debian/changelog ===
fdm (1.6-4ubuntu2) oneiric; urgency=low

  * Build-depend on libtdb-dev rather than tdb-dev.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 17 Aug 2011 23:45:22 +0100

fdm (1.6-4ubuntu1) oneiric; urgency=low

  * 08linkorder.patch: new patch, fixes FTBFS (LP: #770976).

 -- Ilya Barygin <barygin@gmail.com>  Sat, 04 Jun 2011 09:04:23 +0400

fdm (1.6-4build1) oneiric; urgency=low

  * Rebuild for OpenSSL 1.0.0.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 17 May 2011 12:01:40 +0100

fdm (1.6-4) unstable; urgency=low

  * The "package housekeeping" release.
  * Incrementing Standards-Version; no changes needed.
  * Use `debian/source/format' and select "3.0 (quilt)" to make lintian
    happy. No other changes required.

 -- Frank Terbeck <ft@bewatermyfriend.org>  Sun, 05 Sep 2010 12:29:57 +0200

fdm (1.6-3) unstable; urgency=low

  * New patch: 06sslretval.patch: Improve SSL error-handling which led to
    excessive memory allocation with broken mails. (Closes: #595057)
  * New patch: 07incrlinelim.patch: Increase the maximum line limit for a
    mail. This is upstream's recommended workaround to let fdm download
    broken mails which caused #595057.

 -- Frank Terbeck <ft@bewatermyfriend.org>  Sun, 05 Sep 2010 12:21:09 +0200

fdm (1.6-2) unstable; urgency=low

  * Adding -lcrypto do $(LIBS) to support GNU gold (Closes: #554287)
  * Adding 05savemove.patch from Louis Opter. Sorry for the incredibly
    long delay. It fell through the cracks. (Closes: #538194)
  * Incrementing Standards-Version, no changes needed
  * Adding debian/README.source to please lintian yet again.

 -- Frank Terbeck <ft@bewatermyfriend.org>  Wed, 11 Nov 2009 11:51:21 +0100

fdm (1.6-1) unstable; urgency=low

  * New upstream version (Closes: #523673)
  * Switching licencing of debian packaging to ISC, which is the same licence
    fdm itself. This will obsolete the need for the openssl-gpl-override.
  * Incrementing compat level, no changes needed.
  * Incrementing Standards-Version; adding 'set -e' to the package's post*
    scripts as the policy wants it (although I really fail to see how that
    implicit technique is any better than the explicit and very clear
    '|| exit 1' which the package used before).
  * Removing 04support_debianbsds.diff, included upstream.

 -- Frank Terbeck <ft@bewatermyfriend.org>  Tue, 14 Apr 2009 05:34:40 +0200

fdm (1.5-3) unstable; urgency=low

  * The "this time I tried kfreebsd in qemu" release
  * Update 04support_debianbsds.diff to actually build on GNU/k*BSD.

 -- Frank Terbeck <ft@bewatermyfriend.org>  Sun, 27 Apr 2008 08:41:35 +0200

fdm (1.5-2) unstable; urgency=low

  * Switching patch management from dpatch to quilt.
  * Add 04support_debianbsds.diff to (hopefully) support GNU/k*BSD.

 -- Frank Terbeck <ft@bewatermyfriend.org>  Wed, 16 Apr 2008 00:49:21 +0200

fdm (1.5-1) unstable; urgency=low

  * New upstream version
  * Adding Homepage control field
  * Requiring at least version 1.1.1~svn26294-1.1 of tdb-dev
    in Build-Depends: (Closes: #456871)
  * Incrementing Standards-Version and compat level, no changes needed
  * Adding a lintian override for possible-gpl-code-linked-with-openssl
    fdm is licensed under the ISC-license. Only the packaging is GPLed.

 -- Frank Terbeck <ft@bewatermyfriend.org>  Sun, 09 Mar 2008 14:27:21 +0100

fdm (1.4-1) unstable; urgency=low

  * New upstream release.
  * Removing 05fix_cmdline_macros.dpatch and 06fix_regex_match_tags.dpatch,
    fixed upstream.
  * Adding dependency for the newly required trivial database,
    documented in NEWS.
  * Removing 04enable_pcre.dpatch. Unneeded, if PCRE=1 is used constantly
    throughout debian/rules.
  * Fixed typo in this changelog.

 -- Frank Terbeck <ft@bewatermyfriend.org>  Tue, 02 Oct 2007 20:52:19 +0200

fdm (1.3c-3) unstable; urgency=low

  * Including a patch (06fix_regex_match_tags.dpatch) that fixes a
    problem that breaks regex substitution macros for certain
    messages. (Closes: #440231)

 -- Frank Terbeck <ft@bewatermyfriend.org>  Fri, 31 Aug 2007 02:22:31 +0200

fdm (1.3c-2) unstable; urgency=low

  * Including a patch (05fix_cmdline_macros.dpatch) that fixes a problem
    that breaks macros defined on the commandline. (Closes: #440172)
  * Updated a few comments in dpatches.

 -- Frank Terbeck <ft@bewatermyfriend.org>  Thu, 30 Aug 2007 16:09:21 +0200

fdm (1.3c-1) unstable; urgency=low

  * New upstream release.
  * Updated debian/copyright:
    compat/vis.{c,h} are gone
    compat/tree.h was added.
  * Updated 02gmake_use_iquote.dpatch.
  * Listing sample configs from examples/ explicitly in debian/rules.

 -- Frank Terbeck <ft@bewatermyfriend.org>  Mon, 13 Aug 2007 15:35:25 +0200

fdm (1.2-1) unstable; urgency=low

  * New upstream release.
  * Added NEWS file to inform the user about the move to PCRE.
  * Removing 01gmake_destdir.dpatch, 02gmake_install_bin.dpatch,
    05fix_ragged.dpatch and 06fix_MANUAL_typo.dpatch. Included upstream.

 -- Frank Terbeck <ft@bewatermyfriend.org>  Wed, 27 Jun 2007 11:33:00 +0200

fdm (1.1-2) unstable; urgency=low

  * Changing Priority to optional.

 -- Frank Terbeck <ft@bewatermyfriend.org>  Mon, 07 May 2007 19:51:07 +0200

fdm (1.1-1) unstable; urgency=low

  * Initial release. (Closes: #419048)
  * Changed CHILDUSER macro to debianfdm in fdm.h.

 -- Frank Terbeck <ft@bewatermyfriend.org>  Tue, 10 Apr 2007 19:52:08 +0200

=== debian/control ===
Source: fdm
Section: mail
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Frank Terbeck <ft@bewatermyfriend.org>
Build-Depends: debhelper (>= 7), libssl-dev, zlib1g-dev, libpcre3-dev, libtdb-dev (>= 1.1.1~svn26294-1.1), bison, flex, quilt
Homepage: http://fdm.sf.net
Standards-Version: 3.9.1

Package: fdm
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
Description: fetching, filtering and delivering emails
 fdm is a program to fetch mail and deliver it in various ways
 depending on a user-supplied ruleset. Mail may be fetched from
 stdin, IMAP or POP3 servers, or from local maildirs, and filtered
 based on whether it matches a regexp, its size or age, or the output
 of a shell command. It can be rewritten by an external process,
 dropped, left on the server or delivered into maildirs, mboxes, to a
 file or pipe, or any combination.
 .
 fdm is designed to be lightweight but powerful, with a compact but
 clear configuration syntax. It is primarily designed for single-user
 uses but may also be configured to deliver mail in a multi-user
 setup. In this case, it uses privilege separation to minimise the
 amount of code running as the root user.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/quilt/quilt.make

CFLAGS = -Wall -g
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

build: build-stamp
	make PCRE=1 PREFIX=/usr

build-stamp: debian/stamp-patched
	dh_testdir
	$(MAKE) depend PREFIX=/usr PCRE=1
	$(MAKE)        PREFIX=/usr PCRE=1
	touch $@

clean: unpatch
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	$(MAKE) clean
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	$(MAKE) PREFIX=/usr PCRE=1 DESTDIR=$(CURDIR)/debian/fdm install

binary-indep: build install

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs CHANGES
	dh_installdocs
	dh_installexamples examples/f-terbeck.conf examples/n-marriott.conf examples/t-ulmer.conf examples/w-maier.conf fdm-sanitize
	dh_installman
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## fdm 1.6+cvs20111013

=== debian/changelog ===
fdm (1.6+cvs20111013-2) unstable; urgency=low

  * Add patch (04kfreebsd) by Robert Millan to fix build failures on
    kfreebsd. (Closes: #648246)

 -- Frank Terbeck <ft@bewatermyfriend.org>  Wed, 23 Nov 2011 11:27:00 +0100

fdm (1.6+cvs20111013-1) unstable; urgency=low

  * Imported upstream CVS on Oct 13th, 2011
    - Removing a number of patches which are included upstream now.
    - Includes patch which should build with --as-needed. (Closes: #631689)
  * Depending on libtdb-dev now (Closes: #639176)
  * Moving away from explicit quilt-enabled build to pure-3.0 (quilt).
  * Adjusting debian/rules to changes in upstream build system.
  * Incrementing Standards-Version; no changes needed.
  * Use $(MAKE) everywhere in debian/rules.
  * Adding recommended targets to debian/rules to make lintian happy.
  * Remove `MANUAL' in `clean' of `debian/rules' to leave a clean build
    directory.
  * Use `--abort-on-upstream-changes' at all costs.

 -- Frank Terbeck <ft@bewatermyfriend.org>  Thu, 13 Oct 2011 21:05:14 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: fdm
 Section: mail
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Frank Terbeck <ft@bewatermyfriend.org>
-Build-Depends: debhelper (>= 7), libssl-dev, zlib1g-dev, libpcre3-dev, libtdb-dev (>= 1.1.1~svn26294-1.1), bison, flex, quilt
+Maintainer: Frank Terbeck <ft@bewatermyfriend.org>
+Build-Depends: debhelper (>= 7), libssl-dev, zlib1g-dev, libpcre3-dev, libtdb-dev, bison, flex
 Homepage: http://fdm.sf.net
-Standards-Version: 3.9.1
+Standards-Version: 3.9.2
 
 Package: fdm
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,4 @@
 #!/usr/bin/make -f
-
-include /usr/share/quilt/quilt.make
 
 CFLAGS = -Wall -g
 ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
@@ -9,20 +7,28 @@
 	CFLAGS += -O2
 endif
 
+build-arch: build
+
+build-indep: build
+
 build: build-stamp
-	make PCRE=1 PREFIX=/usr
+	$(MAKE) PCRE=1 PREFIX=/usr
+	$(MAKE) -f tools/dist.mk manual
 
-build-stamp: debian/stamp-patched
+build-stamp:
 	dh_testdir
+	sh configure
 	$(MAKE) depend PREFIX=/usr PCRE=1
 	$(MAKE)        PREFIX=/usr PCRE=1
 	touch $@
 
-clean: unpatch
+clean:
 	dh_testdir
 	dh_testroot
 	rm -f build-stamp configure-stamp
+	test -f config.mk || sh configure
 	$(MAKE) clean
+	rm -f config.h config.mk MANUAL
 	dh_clean
 
 install: build

## fdm 1.7

=== Makefile ===
# $Id: Makefile,v 1.183 2009/06/26 15:58:00 nicm Exp $

.SUFFIXES: .c .o
.PHONY: clean regress

VERSION= 1.7

FDEBUG= 1

CC?= cc
YACC= yacc -d
CFLAGS+= -DBUILD="\"$(VERSION)\""
LDFLAGS+= -L/usr/local/lib
LIBS+= -lssl -lcrypto -ltdb -lz

# This sort of sucks but gets rid of the stupid warning and should work on
# most platforms...
CCV!= (LC_ALL=C ${CC} -v 2>&1|awk '/gcc version 4/') || true
.if empty(CCV)
CPPFLAGS:= -I. -I- -I/usr/local/include ${CPPFLAGS}
.else
CPPFLAGS:= -iquote. -I/usr/local/include ${CPPFLAGS}
.endif

.ifdef FDEBUG
LDFLAGS+= -Wl,-E
CFLAGS+= -g -ggdb -DDEBUG
CFLAGS+= -Wno-long-long -Wall -W -Wnested-externs -Wformat=2
CFLAGS+= -Wmissing-prototypes -Wstrict-prototypes -Wmissing-declarations
CFLAGS+= -Wwrite-strings -Wshadow -Wpointer-arith -Wsign-compare
CFLAGS+= -Wundef -Wbad-function-cast -Winline -Wcast-align
.endif

.ifdef COURIER
CFLAGS+= -DLOOKUP_COURIER
LIBS+= -lcourierauth
.endif

.ifdef PCRE
CFLAGS+= -DPCRE
LIBS+= -lpcre
.endif

PREFIX?= /usr/local
INSTALLDIR= install -d
INSTALLBIN= install -g bin -o root -m 555
INSTALLMAN= install -g bin -o root -m 444

SRCS!= echo *.c|sed 's|y.tab.c||g'; echo y.tab.c
.include "config.mk"
OBJS= ${SRCS:S/.c/.o/}

.c.o:
		${CC} ${CPPFLAGS} ${CFLAGS} -c ${.IMPSRC} -o ${.TARGET}

all:		fdm

lex.o:		y.tab.c

y.tab.c:	parse.y
		${YACC} parse.y

fdm:		${OBJS}
		${CC} ${LDFLAGS} -o fdm ${OBJS} ${LIBS}

depend:
		mkdep ${CPPFLAGS} ${CFLAGS} ${SRCS:M*.c}

clean:
		rm -f fdm *.o .depend *~ *.core *.log compat/*.o y.tab.[ch]

clean-all:	clean
		rm -f config.h config.mk

regress:	fdm
		cd regress && ${MAKE}

install:	all
		${INSTALLDIR} ${DESTDIR}${PREFIX}/bin
		${INSTALLBIN} fdm ${DESTDIR}${PREFIX}/bin/
		${INSTALLDIR} ${DESTDIR}${PREFIX}/man/man1
		${INSTALLMAN} fdm.1 ${DESTDIR}${PREFIX}/man/man1/
		${INSTALLDIR} ${DESTDIR}${PREFIX}/man/man5
		${INSTALLMAN} fdm.conf.5 ${DESTDIR}${PREFIX}/man/man5/

uninstall:
		rm -f ${DESTDIR}${PREFIX}/bin/fdm
		rm -f ${DESTDIR}${PREFIX}/man/man1/fdm.1
		rm -f ${DESTDIR}${PREFIX}/man/man5/fdm.conf.5

=== regress/test-pop3/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $Id: Makefile,v 1.1 2007/10/10 20:32:07 nicm Exp $
+# $Id: Makefile,v 1.2 2008/12/17 22:36:23 nicm Exp $
 
 CLEANFILES= *~ *.fifo.{in,out} *.log *.conf
 
@@ -8,7 +8,7 @@
 .for n in ${TESTFILES}
 TARGETS+= ${n}
 ${n}:
-		@HOME=. FDM=../../fdm sh test-pop3.sh ${n}
+		@HOME=. FDM="../../fdm -h" sh test-pop3.sh ${n}
 .endfor
 
 .MAIN:		all

=== debian/changelog ===
fdm (1.7-2) unstable; urgency=low

  * Backport new upstream option `no-tls1' to support more broken servers.
  * Incrementing Standards-Version; no changes needed.
  * Add debian/watch file; from Axel Beckert
  * Add Vcs-* headers to debian/control; again from Axel Beckert. Thanks!

 -- Frank Terbeck <ft@bewatermyfriend.org>  Fri, 10 May 2013 15:45:11 +0200

fdm (1.7-1) unstable; urgency=low

  * New upstream release
  * Incrementing Standards-Version; no changes needed.
  * Refreshed quilt patches, that needed it.
  * Removed 03manpath.patch, since MANPATH can be set via a make variable
    now. (Moving next patch up: 04kfreebsd.patch -> 03kfreebsd.patch)
  * Move to debhelper 9 to get support for dpkg-buildflags, so lintian
    doesn't warn about missing hardening flags anymore. (Incrementing
    compat level and adjusting debhelper dependency.)
  * Thanks to Axel Beckert and Michael Prokop for helping with this
    particular update!

 -- Frank Terbeck <ft@bewatermyfriend.org>  Mon, 06 May 2013 16:46:43 +0200

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,11 @@
 Section: mail
 Priority: optional
 Maintainer: Frank Terbeck <ft@bewatermyfriend.org>
-Build-Depends: debhelper (>= 7), libssl-dev, zlib1g-dev, libpcre3-dev, libtdb-dev, bison, flex
+Build-Depends: debhelper (>= 9~), libssl-dev, zlib1g-dev, libpcre3-dev, libtdb-dev, bison, flex
 Homepage: http://fdm.sf.net
-Standards-Version: 3.9.2
+Vcs-Browser: https://github.com/ft/debian_fdm/
+Vcs-Git: git://github.com/ft/debian_fdm.git
+Standards-Version: 3.9.4
 
 Package: fdm
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -12,20 +12,18 @@
 build-indep: build
 
 build: build-stamp
-	$(MAKE) PCRE=1 PREFIX=/usr
+	dh_auto_build -- PCRE=1
 	$(MAKE) -f tools/dist.mk manual
 
 build-stamp:
 	dh_testdir
-	sh configure
+	dh_auto_configure
 	$(MAKE) depend PREFIX=/usr PCRE=1
-	$(MAKE)        PREFIX=/usr PCRE=1
 	touch $@
 
 clean:
 	dh_testdir
 	dh_testroot
-	rm -f build-stamp configure-stamp
 	test -f config.mk || sh configure
 	$(MAKE) clean
 	rm -f config.h config.mk MANUAL
@@ -36,7 +34,7 @@
 	dh_testroot
 	dh_prep
 	dh_installdirs
-	$(MAKE) PREFIX=/usr PCRE=1 DESTDIR=$(CURDIR)/debian/fdm install
+	$(MAKE) PREFIX=/usr MANDIR=/usr/share/man PCRE=1 DESTDIR=$(CURDIR)/debian/fdm install
 
 binary-indep: build install

## fdm 1.7+cvs20140912

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $Id: Makefile,v 1.183 2009/06/26 15:58:00 nicm Exp $
+# $Id: Makefile,v 1.184 2013/10/16 07:29:08 nicm Exp $
 
 .SUFFIXES: .c .o
 .PHONY: clean regress
@@ -9,18 +9,10 @@
 
 CC?= cc
 YACC= yacc -d
+CPPFLAGS+= -I/usr/local/include -I.
 CFLAGS+= -DBUILD="\"$(VERSION)\""
 LDFLAGS+= -L/usr/local/lib
 LIBS+= -lssl -lcrypto -ltdb -lz
-
-# This sort of sucks but gets rid of the stupid warning and should work on
-# most platforms...
-CCV!= (LC_ALL=C ${CC} -v 2>&1|awk '/gcc version 4/') || true
-.if empty(CCV)
-CPPFLAGS:= -I. -I- -I/usr/local/include ${CPPFLAGS}
-.else
-CPPFLAGS:= -iquote. -I/usr/local/include ${CPPFLAGS}
-.endif
 
 .ifdef FDEBUG
 LDFLAGS+= -Wl,-E

=== regress/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $Id: Makefile,v 1.17 2007/10/11 09:14:09 nicm Exp $
+# $Id: Makefile,v 1.18 2008/12/17 22:36:23 nicm Exp $
 
 CLEANFILES= *~
 
@@ -9,7 +9,7 @@
 TARGETS+= ${n}
 ${n}:
 		@echo ${n}:
-		@HOME=. awk -v CMD="../fdm -vvvnf /dev/stdin" \
+		@HOME=. awk -v CMD="../fdm -hvvvnf /dev/stdin" \
 			-v DEBUG=${DEBUG} -f test.awk ${n}
 .endfor

=== regress/test-imap/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $Id: Makefile,v 1.1 2007/10/11 09:14:09 nicm Exp $
+# $Id: Makefile,v 1.2 2008/12/17 22:36:23 nicm Exp $
 
 CLEANFILES= *~ *.fifo.{in,out} *.log *.conf
 
@@ -8,7 +8,7 @@
 .for n in ${TESTFILES}
 TARGETS+= ${n}
 ${n}:
-		@HOME=. FDM=../../fdm sh test-imap.sh ${n}
+		@HOME=. FDM="../../fdm -h" sh test-imap.sh ${n}
 .endfor
 
 .MAIN:		all

=== regress/tests/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $Id: Makefile,v 1.1 2007/08/30 21:46:33 nicm Exp $
+# $Id: Makefile,v 1.2 2008/12/17 22:36:23 nicm Exp $
 
 CLEANFILES= *~ *.in *.out *.data *.conf
 
@@ -8,7 +8,7 @@
 .for n in ${TESTFILES}
 TARGETS+= ${n}
 ${n}:
-		@HOME=. FDM=../../fdm sh ${n}
+		@HOME=. FDM="../../fdm -h" sh ${n}
 .endfor
 
 .MAIN:		all

=== debian/changelog ===
fdm (1.7+cvs20140912-1build1) bionic; urgency=high

  * No change rebuild against openssl1.1.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 05 Feb 2018 16:49:17 +0000

fdm (1.7+cvs20140912-1) unstable; urgency=low

  * Import upstream CVS state.
  * Incrementing Standards-Version; no changes needed.

 -- Frank Terbeck <ft@bewatermyfriend.org>  Fri, 12 Sep 2014 23:07:34 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: fdm
 Section: mail
 Priority: optional
-Maintainer: Frank Terbeck <ft@bewatermyfriend.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Frank Terbeck <ft@bewatermyfriend.org>
 Build-Depends: debhelper (>= 9~), libssl-dev, zlib1g-dev, libpcre3-dev, libtdb-dev, bison, flex
 Homepage: http://fdm.sf.net
 Vcs-Browser: https://github.com/ft/debian_fdm/
 Vcs-Git: git://github.com/ft/debian_fdm.git
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 
 Package: fdm
 Architecture: any

=== debian/watch ===
version=3
# qa.debian.org runs a redirector which allows a simpler form of URL
# for SourceForge based projects. The format below will automatically
# be rewritten to use the redirector.
http://sf.net/fdm/fdm-(.+)\.(?:zip|tgz|tbz2|txz|tar\.gz|tar\.bz2|tar\.xz)

## fdm 1.9+git20181219

=== debian/changelog ===
fdm (1.9+git20181219-1) unstable; urgency=medium

  * New project homepage: https://github.com/nicm/fdm (Closes: #878646)
  * Note that https://sf.net/projects/fdm/ is another project now!
  * Updated debian/watch to reflect new project location
  * Base package on upstream git snapshot: a450cb8fd1 (Closes: #905781)
  * Upstream switched to autotools and should now be reproducible
    (Closes: #844095)
  * Rename debian packaging repository to pkg-fdm
  * Enable hardening=+all flags in debian/rules
  * Upgrade debhelper dependency
  * Use modern debhelper
  * Add debian/.gitignore
  * debian/rules: Remove --with autoreconf
  * debian/rules: Use pkg-info library instead of parsing changelog
  * debian/control: Use secure uri in Vcs-Git
  * debian/copyright: Update
  * debian/copyright: Reformat to machine-readable dep5-copyright
  * Use debian/examples instead of override_dh_installexamples
  * Update patch adjusting child process user name
  * Remove 02incrlinelim.patch and 03kfreebsd.patch
  * Specify non-exsistent home for debianfdm user
  * Bump standards version to 4.3.0
  * Increase compatibility level to 12

 -- Frank Terbeck <ft@bewatermyfriend.org>  Sat, 12 Jan 2019 14:25:15 +0100

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: fdm
 Section: mail
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Frank Terbeck <ft@bewatermyfriend.org>
-Build-Depends: debhelper (>= 9~), libssl-dev, zlib1g-dev, libpcre3-dev, libtdb-dev, bison, flex
-Homepage: http://fdm.sf.net
-Vcs-Browser: https://github.com/ft/debian_fdm/
-Vcs-Git: git://github.com/ft/debian_fdm.git
-Standards-Version: 3.9.5
+Maintainer: Frank Terbeck <ft@bewatermyfriend.org>
+Build-Depends: debhelper (>= 12), libssl-dev, zlib1g-dev, libpcre3-dev, libtdb-dev, bison, flex
+Homepage: https://github.com/nicm/fdm
+Vcs-Browser: https://github.com/ft/pkg-fdm/
+Vcs-Git: https://github.com/ft/pkg-fdm.git
+Standards-Version: 4.3.0
 
 Package: fdm
 Architecture: any

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/(\d+.\d+)\.tar\.gz/$1\/fdm-$1\.tar\.gz/ \
  https://github.com/nicm/fdm/releases/ .+\/(\d+.\d+)\.tar\.gz

## fdm 2.2+git20250202

=== debian/changelog ===
fdm (2.2+git20250202-3) unstable; urgency=medium

  * [6c9d60e7] Build-depend upon libpcre2-dev

 -- Frank Terbeck <ft@bewatermyfriend.org>  Fri, 05 Sep 2025 23:28:17 +0200

fdm (2.2+git20250202-2) unstable; urgency=medium

  * [41080502] Fix detection patterns in debian/watch (Closes: #1111570)
  * [1b356f9c] gbp: Fix debian version tag pattern in gbp.conf
  * [0d33d161] Improve upstream tarball generation
  * [f370008f] Update debian standards version to 4.7.2

 -- Frank Terbeck <ft@bewatermyfriend.org>  Sun, 31 Aug 2025 20:39:16 +0200

fdm (2.2+git20250202-1) unstable; urgency=medium

  * [96b4e436] Replace obsolete macros AC_HELP_STRING and AC_TRY_LINK,
    from Aaron Ji.
  * [0918b78a] Send UTF8 command to POP3 server (ignore the response),
    because some servers don't like UTF-8 without it.
  * [451c12c6] Update debian standards-version to 4.7.0
  * [a0202224] Update debian package copyright years

 -- Frank Terbeck <ft@bewatermyfriend.org>  Sun, 02 Feb 2025 12:21:03 +0100

fdm (2.2+git20230403-1) unstable; urgency=medium

  * New upstream release.
  * [f1ec1982] Fix bugs in PCRE2 code.
  * [028f59be] Fix use-after-free.
  * Upgrade standards version to 4.6.2.
  * Update debian package copyright years.
  * Update lintian override to renamed tag.
  * Re-Enable PCRE functionality. (Closes: #1034047)

 -- Frank Terbeck <ft@bewatermyfriend.org>  Sat, 08 Apr 2023 18:25:34 +0200

fdm (2.1-1) unstable; urgency=medium

  * New upstream release.
  * Update copyright years.
  * Remove obsolete debian/compat file.
  * Add configuration for git-buildpackage.
  * Specify that the sources do not require root to build.
  * Add upstream meta-data file.
  * watch: Remove filenamemangle option.
  * lintian: Disabled upstream signature check.
  * Upgrade standards version to 4.6.1.
  * Upgrade debhelper compatibility to 13 and newer.

 -- Frank Terbeck <ft@bewatermyfriend.org>  Sat, 11 Jun 2022 16:59:31 +0200

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,19 @@
 Section: mail
 Priority: optional
 Maintainer: Frank Terbeck <ft@bewatermyfriend.org>
-Build-Depends: debhelper (>= 12), libssl-dev, zlib1g-dev, libpcre3-dev, libtdb-dev, bison, flex
+Build-Depends: debhelper (>= 13),
+               debhelper-compat (= 13),
+               libssl-dev,
+               zlib1g-dev,
+               libpcre2-dev,
+               libtdb-dev,
+               bison,
+               flex
+Rules-Requires-Root: no
 Homepage: https://github.com/nicm/fdm
 Vcs-Browser: https://github.com/ft/pkg-fdm/
 Vcs-Git: https://github.com/ft/pkg-fdm.git
-Standards-Version: 4.3.0
+Standards-Version: 4.7.2
 
 Package: fdm
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --no-parallel

.PHONY: override_dh_auto_configure
override_dh_auto_configure:
	dh_auto_configure -- --enable-pcre2

deb_upstream_branch=heads/upstream
deb_branch=heads/master
deb_upstream_version := $(shell echo $(DEB_VERSION) | cut -d- -f1)
deb_package = fdm

.PHONY: generate-orig-tarball
generate-orig-tarball:
	(set -x; pwd; f="$(deb_package)_$(deb_upstream_version).orig.tar.xz"; \
	 test -e "$$f" && exit 0;                                             \
	 base=$$(git merge-base $(deb_upstream_branch) $(deb_branch));        \
	 msg=$$(git log --format=%s -1 "$$base");                             \
	 git archive --format=tar                                             \
	              --prefix="$(deb_package)_$(deb_upstream_version)/"      \
	              "$$base"                                                \
	 | xz -9 > "../$$f";)

=== debian/watch ===
version=4
opts=searchmode=plain,filenamemangle=s/.+\/fdm-(\d+\.\d+)\.tar\.gz/$1\/fdm-$1\.tar\.gz/ \
  https://api.github.com/repos/nicm/fdm/releases \
  https://[^:]+\/fdm-(\d+\.\d+)\.tar\.gz
